﻿// Classic Cretan-type labyrinth
//
// Not much point to this one, since it can also be done freehand in flash.
//
// - Jim Bumgardner

degToRad = Math.PI/180;

++initCtr;
if (initCtr > 1)
	trace("Script called twice!");


MovieClip.prototype.drawCurve = function (x1, y1, cx, cy, x2, y2) {
    	this.moveTo (x1, y1);
     	this.curveTo (cx, cy, x2, y2);
};
   
MovieClip.prototype.drawLine = function (x1, y1, x2, y2) {
    	this.moveTo (x1, y1);
     	this.lineTo (x2, y2);
};

MovieClip.prototype.drawGradCircle = function(rx,ry)
{
	// trace("Drawing Circle " + rx + " " + ry);
  var colors = [0xFFFFFF, 0xFFFFFF ]; // colors
	var ratios = [0x00,0xFF];
	var alphas = [100,0];
	var matrix = { matrixType:"box", x:-rx, y:-ry, w:rx*2, h:ry*2, r: 0 }

	this.moveTo(rx,		0);

 	this.beginGradientFill("radial",colors,alphas,ratios,matrix);
	var crx = rx/Math.cos(22.5*degToRad);
	var cry = ry/Math.cos(22.5*degToRad);
  for (var i = 1; i <= 8; ++i)
  {
		  this.curveTo(Math.cos((i-.5)*2*Math.PI/8)*crx,		Math.sin((i-.5)*2*Math.PI/8)*cry,
					 				 Math.cos(i*2*Math.PI/8)*rx,		Math.sin(i*2*Math.PI/8)*ry);
  }

  this.endFill()
}



function drawCWArc(mc, x,y,radius, aspect, bA,eA)
{
	// trace("rad = " + radius);
	if (eA < bA)
		eA += 360;
	var r = radius;
	var theta = 45*degToRad;
	var cr = radius/Math.cos(theta/2);
	var angle = bA*degToRad;
	var cangle = angle-theta/2;
	var n = Math.floor((eA-bA)/45);
	mc.moveTo(x+r*Math.cos(angle), y+aspect*r*Math.sin(angle));
	for (var i=0;i < n;i++) 
	{
		angle += theta;
		cangle += theta;
		var endX = r*Math.cos (angle);
		var endY = aspect*r*Math.sin (angle);
		var cX = cr*Math.cos (cangle);
		var cY = aspect*cr*Math.sin (cangle);
		mc.curveTo(x+cX,y+cY, x+endX,y+endY);
	}
	// final bit
	theta = (eA-(bA+45*n))*degToRad;
	if (theta > 0.01) {	// arbitrary limit
		cr = radius/Math.cos(theta/2);
		angle += theta;
		cangle = angle-theta/2;
		var endX = r*Math.cos (angle);
		var endY = aspect*r*Math.sin (angle);
		var cX = cr*Math.cos (cangle);
		var cY = aspect*cr*Math.sin (cangle);
		mc.curveTo(x+cX,y+cY, x+endX,y+endY);
	}
}


// Maze render offset (keeps mazed centered)
MCX = -1.5;
MCY = 1;
PW = 300/17;	// path width (17 might be okay...)
AR = 10/11;		// aspect ratio for Y
				// x,y,w,h,rad,beg,end


// Compute angle covering path of width PW for circle number N (which has Radius PW*N)
function arcCirc(n)
{
		return (180/(Math.PI*n));	// angle covering distance PW
}

function arcPosX(n, sc)
{
	return n*PW*Math.cos((90+arcCirc(n)*sc)*degToRad);
}

function arcPosY(n, sc)
{
	return AR*n*PW*Math.sin((90+arcCirc(n)*sc)*degToRad);
}

// Left/Right angles from center for concentric circle
var scL = [1, 2,2,2,2,3,3,2];
var scR = [1, 2,3,3,2,2,3,3];

// Coords and control points for remaining curves
var cP = [
						[1, 1,		1,0,		2,0.5,			3,1,	3,2],
						[2,-2, 		2,-1, 		3,-1.5, 		4,-2, 4,-3],
						[5, 2,		5, 1,		6,1.5,			7,2,	7,3],
						[6,-2,		6,-1,		7,-1.5,			8,-2,	8,-3],
						[1,-1,		2,0,		6,0,			8,0,	8,2],
						[4, 2,		4,1,		4.5,0,		5,-1,	5,-2]
				];	

function drawMaze()
{
	this.clear();

	AR = 10/12;

	this.drawGradCircle(8*PW,8*PW*AR);
	this.lineStyle(7,0x004400,100);

	for (var n = 1; n <= 8; ++n) 
	{
		var appR = arcCirc(n);	// angle covering distance PW
		var sc;
		drawCWArc(this, 0, 0, n*PW, AR,	90+appR*scL[n-1], 90-appR*scR[n-1]);
	}


	for (var n = 0; n < 6; ++n) {
		this.drawCurve(arcPosX(cP[n][0], cP[n][1]), arcPosY(cP[n][0], cP[n][1]), 
						   		 arcPosX(cP[n][2], cP[n][3]), arcPosY(cP[n][2], cP[n][3]),
						   		 arcPosX(cP[n][4], cP[n][5]), arcPosY(cP[n][4], cP[n][5]) );

		this.curveTo(	 arcPosX(cP[n][6], cP[n][7]), arcPosY(cP[n][6], cP[n][7]),
						   		 arcPosX(cP[n][8], cP[n][9]), arcPosY(cP[n][8], cP[n][9]) );
	}
	this.onEnterFrame = undefined;
}


function updateContainer()
{
	// this._rotation += 1;
}

function init()
{
	// trace("Init 1");
	if (inited != undefined)
		return;
	// var h = this.attachMovie("dummy", "yin", 0);
	var cont = this.createEmptyMovieClip("container", 0);
	cont._x = 150;
	cont._y = 150;
	cont.onEnterFrame = updateContainer;
	var mc = cont.createEmptyMovieClip("maze", 0);
	mc._x = 0;
	mc._y = 0;
	mc.onEnterFrame = drawMaze;
	inited = true;
}

init();